From 7f1c10e0065690107c464d375965aeeda27d478e Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Tue, 22 Jun 2021 23:22:17 +0000
Subject: [PATCH] arm64 port x265_filterPixelToShort_*_neon

convert_p2s[  4x4]		1.39x 	 4.30     	 5.99
convert_p2s[  8x8]		2.27x 	 6.04     	 13.69
convert_p2s[16x16]		1.55x 	 25.08    	 38.86
convert_p2s[32x32]		1.52x 	 101.97   	 154.98
convert_p2s[64x64]		1.46x 	 425.74   	 622.36
convert_p2s[  8x4]		2.10x 	 3.01     	 6.32
convert_p2s[  4x8]		1.90x 	 6.03     	 11.47
convert_p2s[ 16x8]		1.47x 	 12.21    	 17.93
convert_p2s[ 8x16]		1.94x 	 13.29    	 25.76
convert_p2s[32x16]		1.49x 	 50.63    	 75.57
convert_p2s[16x32]		1.55x 	 49.96    	 77.63
convert_p2s[64x32]		1.47x 	 212.07   	 312.09
convert_p2s[32x64]		1.48x 	 205.15   	 304.63
convert_p2s[16x12]		1.65x 	 17.61    	 29.13
convert_p2s[12x16]		6.25x 	 23.94    	 149.53
convert_p2s[ 16x4]		1.57x 	 5.36     	 8.43
convert_p2s[ 4x16]		1.75x 	 13.58    	 23.77
convert_p2s[32x24]		1.50x 	 75.43    	 113.10
convert_p2s[24x32]		2.70x 	 78.12    	 210.53
convert_p2s[ 32x8]		1.48x 	 25.00    	 37.05
convert_p2s[ 8x32]		1.63x 	 29.09    	 47.44
convert_p2s[64x48]		1.46x 	 318.76   	 466.76
convert_p2s[64x16]		1.46x 	 105.51   	 154.46
convert_p2s[16x64]		1.58x 	 98.66    	 155.66
---
 source/common/aarch64/asm-primitives.cpp |  25 ++++
 source/common/aarch64/ipfilter8.S        | 181 +++++++++++++++++++++++
 source/common/aarch64/ipfilter8.h        |  25 ++++
 3 files changed, 231 insertions(+)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index 6fe8c96..e5a1f03 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -214,6 +214,31 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.cu[BLOCK_4x4].psy_cost_pp = PFX(psyCost_4x4_neon);
 #endif // !HIGH_BIT_DEPTH
 
+        // filterPixelToShort
+        p.pu[LUMA_4x4].convert_p2s[NONALIGNED]   = PFX(filterPixelToShort_4x4_neon);
+        p.pu[LUMA_4x8].convert_p2s[NONALIGNED]   = PFX(filterPixelToShort_4x8_neon);
+        p.pu[LUMA_4x16].convert_p2s[NONALIGNED]  = PFX(filterPixelToShort_4x16_neon);
+        p.pu[LUMA_8x4].convert_p2s[NONALIGNED]   = PFX(filterPixelToShort_8x4_neon);
+        p.pu[LUMA_8x8].convert_p2s[NONALIGNED]   = PFX(filterPixelToShort_8x8_neon);
+        p.pu[LUMA_8x16].convert_p2s[NONALIGNED]  = PFX(filterPixelToShort_8x16_neon);
+        p.pu[LUMA_8x32].convert_p2s[NONALIGNED]  = PFX(filterPixelToShort_8x32_neon);
+        p.pu[LUMA_12x16].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_12x16_neon);
+        p.pu[LUMA_16x4].convert_p2s[NONALIGNED]  = PFX(filterPixelToShort_16x4_neon);
+        p.pu[LUMA_16x8].convert_p2s[NONALIGNED]  = PFX(filterPixelToShort_16x8_neon);
+        p.pu[LUMA_16x12].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_16x12_neon);
+        p.pu[LUMA_16x16].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_16x16_neon);
+        p.pu[LUMA_16x32].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_16x32_neon);
+        p.pu[LUMA_16x64].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_16x64_neon);
+        p.pu[LUMA_24x32].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_24x32_neon);
+        p.pu[LUMA_32x8].convert_p2s[NONALIGNED]  = PFX(filterPixelToShort_32x8_neon);
+        p.pu[LUMA_32x16].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_32x16_neon);
+        p.pu[LUMA_32x24].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_32x24_neon);
+        p.pu[LUMA_32x32].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_32x32_neon);
+        p.pu[LUMA_32x64].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_32x64_neon);
+        p.pu[LUMA_64x16].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x16_neon);
+        p.pu[LUMA_64x32].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x32_neon);
+        p.pu[LUMA_64x48].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x48_neon);
+        p.pu[LUMA_64x64].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x64_neon);
     }
 }
 } // namespace X265_NS
diff --git a/source/common/aarch64/ipfilter8.S b/source/common/aarch64/ipfilter8.S
index 908c7db..28d8acc 100644
--- a/source/common/aarch64/ipfilter8.S
+++ b/source/common/aarch64/ipfilter8.S
@@ -29,7 +29,188 @@
 
 .text
 
+// filterPixelToShort(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride)
+function x265_filterPixelToShort_4x4_neon
+    add             x3, x3, x3
+    movi            v2.8h, #0xe0, lsl #8
+    ld1             {v0.s}[0], [x0], x1
+    ld1             {v0.s}[1], [x0], x1
+    ushll           v3.8h, v0.8b, #6
+    add             v3.8h, v3.8h, v2.8h
+    st1             {v3.d}[0], [x2], x3
+    st1             {v3.d}[1], [x2], x3
+    ld1             {v1.s}[0], [x0], x1
+    ld1             {v1.s}[1], [x0], x1
+    ushll           v4.8h, v1.8b, #6
+    add             v4.8h, v4.8h, v2.8h
+    st1             {v4.d}[0], [x2], x3
+    st1             {v4.d}[1], [x2], x3
+    ret
+endfunc
+
+.macro x265_filterPixelToShort_4xN h r
+function x265_filterPixelToShort_4x\h\()_neon
+    add             x3, x3, x3
+    movi            v4.8h, #0xe0, lsl #8
+.rept \r
+    ld1             {v0.8b}, [x0], x1
+    ld1             {v1.8b}, [x0], x1
+    ushll           v0.8h, v0.8b, #6
+    ushll           v1.8h, v1.8b, #6
+    add             v2.8h, v0.8h, v4.8h
+    add             v3.8h, v1.8h, v4.8h
+    st1             {v2.4h}, [x2], x3
+    st1             {v3.4h}, [x2], x3
+.endr
+    ret
+endfunc
+.endm
+
+x265_filterPixelToShort_4xN 8 4
+x265_filterPixelToShort_4xN 16 8
+
+.macro x265_filterPixelToShort_8xN h r
+function x265_filterPixelToShort_8x\h\()_neon
+    add             x3, x3, x3
+    movi            v4.8h, #0xe0, lsl #8
+.rept \r
+    ld1             {v0.8b}, [x0], x1
+    ld1             {v1.8b}, [x0], x1
+    ushll           v0.8h, v0.8b, #6
+    ushll           v1.8h, v1.8b, #6
+    add             v2.8h, v0.8h, v4.8h
+    add             v3.8h, v1.8h, v4.8h
+    st1             {v2.8h}, [x2], x3
+    st1             {v3.8h}, [x2], x3
+.endr
+    ret
+endfunc
+.endm
+
+x265_filterPixelToShort_8xN 4 2
+x265_filterPixelToShort_8xN 8 4
+x265_filterPixelToShort_8xN 16 8
+x265_filterPixelToShort_8xN 32 16
+
+function x265_filterPixelToShort_12x16_neon
+    add             x3, x3, x3
+    sub             x3, x3, #16
+    movi            v5.8h, #0xe0, lsl #8
+.rept 16
+    ld1             {v0.16b}, [x0], x1
+    ushll           v2.8h, v0.8b, #6
+    ushll2          v3.8h, v0.16b, #6
+    add             v2.8h, v2.8h, v5.8h
+    add             v3.8h, v3.8h, v5.8h
+    st1             {v2.16b}, [x2], #16
+    st1             {v3.8b}, [x2], x3
+.endr
+    ret
+endfunc
+
+.macro filterPixelToShort_16xN h
+function x265_filterPixelToShort_16x\h\()_neon
+    add             x3, x3, x3
+    movi            v5.8h, #0xe0, lsl #8
+.rept \h
+    ld1             {v0.16b}, [x0], x1
+    ushll           v2.8h, v0.8b, #6
+    ushll2          v3.8h, v0.16b, #6
+    add             v2.8h, v2.8h, v5.8h
+    add             v3.8h, v3.8h, v5.8h
+    st1             {v2.16b-v3.16b}, [x2], x3
+.endr
+    ret
+endfunc
+.endm
+        
+filterPixelToShort_16xN 4
+filterPixelToShort_16xN 8
+filterPixelToShort_16xN 12
+filterPixelToShort_16xN 16
+filterPixelToShort_16xN 32
+filterPixelToShort_16xN 64
+
+function x265_filterPixelToShort_24x32_neon
+    add             x3, x3, x3
+    movi            v6.8h, #0xe0, lsl #8
+.rept 32
+    ld1             {v0.8b-v2.8b}, [x0], x1
+    ushll           v3.8h, v0.8b, #6
+    ushll           v4.8h, v1.8b, #6
+    ushll           v5.8h, v2.8b, #6
+    add             v3.8h, v3.8h, v6.8h
+    add             v4.8h, v4.8h, v6.8h
+    add             v5.8h, v5.8h, v6.8h
+    st1             {v3.16b-v5.16b}, [x2], x3
+.endr
+    ret
+endfunc
+
+.macro filterPixelToShort_32xN h
+function x265_filterPixelToShort_32x\h\()_neon
+    add             x3, x3, x3
+    movi            v6.8h, #0xe0, lsl #8
+.rept \h
+    ld1             {v0.16b-v1.16b}, [x0], x1
+    ushll           v2.8h, v0.8b, #6
+    ushll2          v3.8h, v0.16b, #6
+    ushll           v4.8h, v1.8b, #6
+    ushll2          v5.8h, v1.16b, #6
+    add             v2.8h, v2.8h, v6.8h
+    add             v3.8h, v3.8h, v6.8h
+    add             v4.8h, v4.8h, v6.8h
+    add             v5.8h, v5.8h, v6.8h
+    st1             {v2.16b-v5.16b}, [x2], x3
+.endr
+    ret
+endfunc
+.endm
+
+filterPixelToShort_32xN 8
+filterPixelToShort_32xN 16
+filterPixelToShort_32xN 24
+filterPixelToShort_32xN 32
+filterPixelToShort_32xN 64
+
+.macro filterPixelToShort_64xN h r
+function x265_filterPixelToShort_64x\h\()_neon
+    add             x3, x3, x3
+    sub             x3, x3, #0x40
+    movi            v4.8h, #0xe0, lsl #8
+    mov             x9, #\r
+.loop_filterP2S_64x\h:
+    subs            x9, x9, #1
+.rept 2
+    ld1             {v0.16b-v3.16b}, [x0], x1
+    ushll           v16.8h, v0.8b, #6
+    ushll2          v17.8h, v0.16b, #6
+    ushll           v18.8h, v1.8b, #6
+    ushll2          v19.8h, v1.16b, #6
+    ushll           v20.8h, v2.8b, #6
+    ushll2          v21.8h, v2.16b, #6
+    ushll           v22.8h, v3.8b, #6
+    ushll2          v23.8h, v3.16b, #6
+    add             v16.8h, v16.8h, v4.8h
+    add             v17.8h, v17.8h, v4.8h
+    add             v18.8h, v18.8h, v4.8h
+    add             v19.8h, v19.8h, v4.8h
+    add             v20.8h, v20.8h, v4.8h
+    add             v21.8h, v21.8h, v4.8h
+    add             v22.8h, v22.8h, v4.8h
+    add             v23.8h, v23.8h, v4.8h
+    st1             {v16.16b-v19.16b}, [x2], #0x40
+    st1             {v20.16b-v23.16b}, [x2], x3
+.endr
+    bgt             .loop_filterP2S_64x\h
+    ret
+endfunc
+.endm
 
+filterPixelToShort_64xN 16 8
+filterPixelToShort_64xN 32 16
+filterPixelToShort_64xN 48 24
+filterPixelToShort_64xN 64 32
 
 .macro qpel_filter_0_32b
     movi            v24.8h, #64
diff --git a/source/common/aarch64/ipfilter8.h b/source/common/aarch64/ipfilter8.h
index f9ed91e..2bc81bd 100644
--- a/source/common/aarch64/ipfilter8.h
+++ b/source/common/aarch64/ipfilter8.h
@@ -24,6 +24,31 @@
 #ifndef X265_IPFILTER8_AARCH64_H
 #define X265_IPFILTER8_AARCH64_H
 
+void x265_filterPixelToShort_4x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_4x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_4x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_8x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_8x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_8x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_8x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_12x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_16x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_16x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_16x12_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_16x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_16x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_16x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_24x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_32x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_32x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_32x24_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_32x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_32x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_48x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_64x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_64x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_64x48_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_64x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
 
 void x265_interp_8tap_horiz_ps_4x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
 void x265_interp_8tap_horiz_ps_4x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-- 
2.25.1

